using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

// Include the namespace for IC Imaging Control
using TIS.Imaging;

namespace Neutral_Parameter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private TIS.Imaging.ICImagingControl icImagingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.icImagingControl1 = new TIS.Imaging.ICImagingControl();
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// icImagingControl1
			// 
			this.icImagingControl1.DeBayerMode = TIS.Imaging.DeBayerModes.Edgesensing;
			this.icImagingControl1.DeBayerStartPattern = TIS.Imaging.DeBayerStartPatterns.BG;
			this.icImagingControl1.ImageRingBufferSize = 5;
			this.icImagingControl1.LiveDisplayHeight = 480;
			this.icImagingControl1.LiveDisplayWidth = 640;
			this.icImagingControl1.LiveShowLastBuffer = true;
			this.icImagingControl1.Location = new System.Drawing.Point(8, 16);
			this.icImagingControl1.MemoryCurrentGrabberColorformat = TIS.Imaging.ICImagingControlColorformats.ICRGB24;
			this.icImagingControl1.Name = "icImagingControl1";
			this.icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
			this.icImagingControl1.SinkCompatibilityMode = true;
			this.icImagingControl1.Size = new System.Drawing.Size(272, 216);
			this.icImagingControl1.TabIndex = 0;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.icImagingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.icImagingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			icImagingControl1.ShowDeviceSettingsDialog();
			if(icImagingControl1.DeviceValid)
			{
				// Declare the Simple Property helper class object.
				TIS.Imaging.VCDHelpers.VCDSimpleProperty SimpleProperty;

				// Initialize the SimpleProperty class to access the properties of our ICImagingControl object.
				SimpleProperty = TIS.Imaging.VCDHelpers.VCDSimpleModule.GetSimplePropertyContainer(icImagingControl1.VCDPropertyItems);

				// Disable the automatics
				if( SimpleProperty.AutoAvailable(VCDIDs.VCDID_Gain))
					SimpleProperty.Automation[VCDIDs.VCDID_Gain] = false;

				if( SimpleProperty.AutoAvailable(VCDIDs.VCDID_WhiteBalance))
					SimpleProperty.Automation[VCDIDs.VCDID_WhiteBalance] = false;

				if( SimpleProperty.AutoAvailable(VCDIDs.VCDID_Brightness))
					SimpleProperty.Automation[VCDIDs.VCDID_Brightness] = false;

				if( SimpleProperty.AutoAvailable(VCDIDs.VCDID_Gamma))
					SimpleProperty.Automation[VCDIDs.VCDID_Gamma] = false;

				// Set the property values
				SimpleProperty.RangeValue[VCDIDs.VCDID_Brightness] = 0;
				// Gain neutral is 180 for FireWire and 260 for USB cameras of The Imaging Source.
				SimpleProperty.RangeValue[VCDIDs.VCDID_Gain] = 180;
				SimpleProperty.RangeValue[VCDIDs.VCDElement_WhiteBalanceBlue] = 32;
				SimpleProperty.RangeValue[VCDIDs.VCDElement_WhiteBalanceRed] = 32;
				SimpleProperty.RangeValue[VCDIDs.VCDID_Gamma] = 10;
				SimpleProperty.RangeValue[VCDIDs.VCDID_Hue] = 180;
				SimpleProperty.RangeValue[VCDIDs.VCDID_Saturation] = 127;

				icImagingControl1.LiveStart();
			}
			

		}
	}
}
